@part[ethernet, root "manual"]

@string[sectiontitle = "Ethernet Etiquette"]
@newpage

@section[Ethernet Etiquette]

The Ethernet is a shared communication system, and certain
actions can unintentionally disrupt it.  This section describes
practices and procedures that can minimize troubles seen by other
users of the same Ethernet.
@Begin[enumerate]
Most PC's are attached using "thin Ethernet," which means
that the Ethernet wire comes down to the back of the PC where
it connects to the PC with a T-connector.  The continuity of
the Ethernet (and of service to other users) depends on the
integrity of the connection through the T-connector.  If you
disconnect your PC from the Ethernet, you should:
@Begin[enumerate]
make certain that the continuity of the thin Ethernet
through the T-connector is maintained.

Make certain that the T-connector is not touching
anything metallic or conductive.

@Begin[multiple]
If the disconnection will be for more than a few minutes, replace the
T-connector with a barrel connector.  (Unterminated T-connectors
provide an opportunity for noise, radiation, and echoes; one such
opportunity won't necessarily bring down an Ethernet, but a large
number of them can.)

If you are at one end of an Ethernet segment, you will find that
one side of your T-connector has the Ethernet coming in, while the
other side has a terminator attached. Continuity from the Ethernet to
the terminator is just as important as continuity from one section of
cable to the next, so if you disconnect your PC from the Ethernet, you
should make certain that the Ethernet continues to be terminated,
using either the T-connector or a barrel connector.
@End[multiple]
@End[enumerate]

The Internet address used for your PC when it is attached to
the Ethernet must be unique, and it must be manually assigned.
Thus some care is needed to insure that two PC's don't
accidentally try to operate using the same Internet address.
Each PC/IP command has this Internet address embedded in it (as
part of customization).  You should not change the internet
address that your PC uses without coordinating the change with
the central registry of addresses of other PC's.  Also, if you
exchange diskettes containing network programs with other PC/IP
users be sure that you recustomize the internet address before
using the programs.
@End[enumerate]


23 October 1983.  This document is in file ethernet.mss
