@part[hosts, root "manual"]

@string[sectiontitle = "MIT Hosts"]
@newpage

@section[M.I.T. Host Names]

@Begin[format]
A list of names found in IP name table servers, of hosts on the 
M.I.T. campus that provide some IP protocol-based services.  
All integers in these tables are decimal.

Named IP-speaking hosts on the ARPANET (network 10.x.0.y)

name                aliases                       x.0.y

MIT-GATEWAY         MIT-GW, GW                    0.0.77
MIT-XX              XX                            0.0.44
MIT-Multics         Multics, mult                 0.0.6
MIT-Devmultics      cisl, devmultics              3.0.31
MIT-MC              MC                            3.0.44
MIT-ML              ML                            3.0.6
MIT-TAC                                           2.0.77
MIT-TST-GW          MIT-TST, TST, TST-GW          2.0.44


Named IP-speaking hosts on the Pronet ring (network 18.10.0.x)

name                aliases                        x

AJAX                MIT-AJAX                      64
BIG-BLUE            MIT-BIG-BLUE, BIGBLUE 
                      MIT-BIGBLUE                195
BLUE-DANUBE         MIT-BLUE-DANUBE, DANUBE      193
BLUE-LIGHT          MIT-BLUE-LIGHT               192
BOLD                MIT-BOLD                      69
Borax               MIT-Borax                     65
BRIDGE              MIT-BRIDGE, MIT-BR             5
CLS                 MIT-CLS                       76
Comet               MIT-Comet                     66
CSR                 MIT-CSR, printer, CSR2         8
Dash                MIT-Dash                      73
Dutch               MIT-Dutch                     67
DUZ                 MIT-DUZ                       72
FAB                 MIT-FAB                       70
FLA                 MIT-FLA, NEWT, 
                      MIT-NEWTOWNE-VARIETY        75
GRAPE-NEHI          MIT-GRAPE-NEHI                77
Heineken            MIT-Heineken                  78
Kirin               MIT-Kirin                     81
MacEwan             MIT-MacEwan                   80
Milo                MIT-Milo                      86
Molson              MIT-Molson                    82
DM                  MIT-DM                       129
MIT-GW-LCS                                         4
MIT-NMS                                           24
MrClean             MIT-MrClean                   68
MOTHER              MIT-MOTHER                   194
NMS                                               30
OA                  MIT-OA                        79
Opus                MIT-Opus                      87

	         (continued on next page)


PCGW                MIT-PCGW, TIU                 40
PRJ                 MIT-PRJ                       71
Rinso               MIT-Rinso                     88
SLUDGE              MIT-SLUDGE, MIT-SL, SL         6
Tide                MIT-Tide                      74
TST-V2              MIT-TST-V2                    41


Named IP-speaking hosts on the 10 Mbit LCS Ethernet (network
18.26.0.x)

Name                Alias                         x

BLUE-APOLLO         MIT-BLUE-APOLLO              136
BABY-BLUE           BABY, MIT-BABY-BLUE           24
BLUE-BAYOU          MIT-BLUE-BAYOU, BAYOU         26
BLUE-BLOOD          MIT-BLUE-BLOOD, BLOOD         31
BLUE-JEANS          MIT-BLUE-JEANS                30
BLUE-SUEDE-SHOES    MIT-BLUE-SUEDE-SHOES, 
                      BLUE-SUEDE                  27
BLUE-THUNDER        MIT-BLUE-THUNDER, THUNDER     25
CAR-WASH            CAR-WASH-BLUES, 
                      MIT-CAR-WASH-BLUES          29
CHARMIN             MIT-CHARMIN                    1
CJT                 MIT-CJT                       45
COKE                MIT-COKE                      39
CUB                 MIT-CUB                       21
DR-PEPPER           MIT-DR-PEPPER, MIT-DP, DP     40
GUANO               MIT-GUANO                     44
MELKOR              MIT-MELKOR                     8
MISTY-BLUE          MIT-MISTY-BLUE, MISTY         28
PEPSI               MIT-PEPSI                     41
PLUTO               MIT-PLUTO                     35
SELTZER             MIT-SELTZER                   42
VAX                 MIT-VAX                       95
VAXLET              MIT-VAXLET                    64
WILD-BLUE-YONDER    MIT-WILD-BLUE-YONDER, WBY, 
                      MIT-WBY, WILD-BLUE          75
XBOOT               MIT-XBOOT                     34
ZUD                 MIT-ZUD                       38


Named IP-speaking hosts at MIT Project Athena (network 18.x.0.y)

Name                Alias                       x.0.y

APHRODITE           MIT-APHRODITE              58.0.12
APOLLO              MIT-APOLLO                 58.0.10
ARES                MIT-ARES                   58.0.5
ARTEMIS             MIT-ARTEMIS, ARTY          58.0.11
ATHENA              MIT-ATHENA                 58.0.1
ATLAS               MIT-ATLAS                  58.0.15
CHARON              MIT-CHARON, SIPBVAX        58.0.13
DEMETER             MIT-DEMETER                58.0.4
HERA                MIT-HERA                   58.0.3
PERSEPHONE          MIT-PERSEPHONE, PHONE      58.0.8
POSEIDON            MIT-POSEIDON               58.0.6
PROMETHEUS          MIT-PROMETHEUS, PROM       58.0.14
ZEUS                MIT-ZEUS                   58.0.2

	         (continued on next page)


Named IP-speaking hosts on the 3 Mbit experimental Ethernet
(network 18.2.0.x)

name                aliases                        x

alto214b                                          56
alto502                                          130
alto503                                          100
alto508                                           96
alto509                                           18
alto510                                           20
alto511                                           72
alto520                                          170
alto524             Guttag                        32
alto828             Medg                         134
csg                                               15
MIT-spooler         spooler, spool, sp           128
MIT-SHELOB          SHELOB                       127
muriel                                            80
NP-alto                                          129
OA-alto                                           56


IP-forwarding internetwork gateways:

Fifth floor bridge:
     proNET ring:        (no name)                18.10.0.5
     3 Mbit Ethernet:    MIT-BR-ETHERNET, MIT-BR  18.2.0.7

ARPANET gateway I:
     proNET ring:        (no name)                18.10.0.4
     ARPANET:            MIT-GATEWAY              10.0.0.77

PC Concentrator:
     proNET ring:        MIT-PCGW                 18.10.0.40
     Serial line net:    (no name)                18.9.0.128

ARPANET gateway II:
     proNET ring:        (no name)                18.10.0.41
     ARPANET:            MIT-TST-GW               10.2.0.44

Ethernet gateway:
     proNET ring:        MIT-SLUDGE               18.10.0.6
     10 Mbit Ethernet:   (no name)                18.26.0.132

IP-to-CHAOS gateway:
     proNET ring         MIT-GROSS                18.10.0.9
     AI Ethernet

Location of IP name tables in character format at M.I.T.:

     MIT-XX	PS:<terminet>auxiliary-host.table
     MIT-AJAX	/etc/net/Hostmap/hosts.txt
     MIT-Multics  invoke >lib>net>e>dsht [-all]


@End[format]
31 October 1984.  This document is in file hosts.mss
