@part[iprint, root "manual"]

@string[sectiontitle = "@b<iprint>"]
@newpage

@section[Iprint]
PC/@b[iprint], version 1.1

A program to send a text file to an Imagen print server.


@Begin[format]
Usage

     @b[iprint] filename
or
     @b[iprint] -n filename
or
     @b[iprint] -q filename
@End[format]

sends the file @i"filename" to the default print server, using the
standard protocol for the Imagen family of print servers.  
PC/@b[iprint] specifies a default format that simulates an 80-character, 
10-pitch line printer.  It arranges for a header line containing 
the name of the file and the current date and time to appear at the 
top of each page, and it attaches a cover sheet containing the 
user's name.  If the option "-n" is given, the
header line is omitted.  If the option "-q" is given, the @b[iprint]
command displays no messages unless it encounters an error.


@subsection[Customization]

The following parameters of @b[iprint] can be customized with the
PC/@b[custom] command:
@Begin[enumerate]
Internet address of the print server. Note that @b[lpr] also uses
the print server address when connecting to a Unix printer spooler.
The print server address cannot be customized separately for
@b[iprint] and @b[lpr].

Name of the user, for the cover sheet.
@End[enumerate]

@subsection[Notes]

All PCIP packages follow the DOS convention of returning an
ERRORLEVEL value when they exit.  For use in batch files, 
PC/@b[iprint] returns ERRORLEVEL=0 if the printer service accepts the 
file, and ERRORLEVEL=1 otherwise.



23 January 1986.  This document is in file iprint.mss
