@part[onhook, root "manual"]

@string[sectiontitle = "@b<onhook> and @b<offhook>"]
@newpage

@section[Onhook and Offhook]

PC/@b[offhook]
PC/@b[onhook]


Programs to connect or disconnect (in telephone jargon, "place
off-hook or on-hook" and in common parlance, "pick up or hang
up") the telephone line attached to a serial port on the PC.

@Begin[format]
Usage:

	@b[offhook]
	@b[onhook]
@End[format]

These commands are provided for the scenario in which several
different PC/IP commands are to be used in a single session, via
a dial-up serial line.  The @b"offhook" command instructs the
attached modem that the computer is prepared to use the serial
line (by turning on the signal "data terminal ready" in the modem
interface.)  By convention, PC/IP commands that use the serial
line always restore the on-hook/off-hook status of that
serial line as they exit.  At the completion of the session,
the user may issue an @b"onhook" command to disconnect the
telephone line.

Note that the terminal emulator command, PC/@b[term], is also useful
in management of on-hook and off-hook status, especially in the
case where either the modem or the computer at the other end of
the serial line is controlled by sending ASCII characters. Rather
than starting a session with the @b"offhook" command one starts
with @b"term", using the emulator to tell the modem and switches
how to connect things up.  Then, the user exits term with F10/q,
which leaves the serial port in off-hook status.  At the
completion of the session, the user issues the @b"onhook" command
as usual.

The commands PC/@b[onhook] and PC/@b[offhook] operate on serial port
number one, known in PC documentation as "COM1:".


23 October 1983.  This document is in file onhook.mss
