@part[term, root "manual"]

@string[sectiontitle = "@b<term>"]
@newpage

@section[Term]
PC/@b[term]

A terminal emulator for the IBM Personal Computer.  This program 
is not strictly a part of the PC/IP network software, since it 
makes no use of the IP protocol family.  It turns the PC into a 
terminal so that it may be used to log in to hosts that provide 
dial-up login facilities.  It is included as part of the PC/IP 
package because it uses a terminal emulation package that is 
identical to the one used in PC/telnet.

@subsection[Operating instructions]
@Begin[itemize]
To run the emulator type the DOS command @c"TERM".  It will immediately
activate "data-terminal-ready", which notifies the attached modem or
host computer system of its presence. It then clears the screen and
begins emulation, without any greeting messages.

To exit the emulator without deactivating "data-terminal- ready", type
F10, followed by "q".  This method of exit leaves the modem or
attached computer system with the impression that the terminal is
still attached.  (exit off-hook)

To exit the emulator and deactivate "data-terminal-ready", type F10,
followed by "c". This method of exit tells the modem  or attached
computer system that the terminal has been  disconnected.  (exit
on-hook)

To exit the emulator with "data-terminal-ready" restored  to the value
it had when the emulator command was first typed,  type break
(control-scrolllock).

To send a break type F9.

To set configuration options type F10, follow instructions.

@Begin[format]
   Standard terminal configuration options: 
     full/half duplex     line discard/wrap       baud rate

   Extra emulator configuration options:
     reverse BS/DEL       normal/inverse video    select serial port
@End[format]

   Type F10 again to exit from the option-setting menu.

Type F10 twice before using the PC Print-Screen feature, to restore
the screen buffer to the format expected by PrtSc.
@End[itemize]

@subsection[Configuration customization]

The "power-up configuration" may be customized by using the DOS
DEBUG command as follows:
@Begin[enumerate]
While in DOS, type the command "DEBUG TERM.COM"

To the debugger, type command "g" to  enter the emulator.

Hit key F10 and set the desired power-up configuration.

Choose menu item "q" to return to the debugger.

Type command "w" to save the new configuration on the disk.

Type command "q" to return to DOS.
@End[enumerate]

For a list of keyboard conventions and terminal emulation 
limitations, see the writeup of PC/@b[telnet], which uses the same 
terminal emulator.


9 June 1983.  This document is in file term.mss
