/* $Header: resolve_host.c,v 1.2 85/04/03 15:40:33 lwa Exp $ */

#include <stdio.h>
#include <sys/types.h>
#include <errno.h>
#include <signal.h>
#include <sys/socket.h>
#include <netdb.h>
#include <netinet/in.h>


struct sockaddr_in *
resolve_host(name)

/* Resolve the specified host name into an internet address.  The "name" may
 * be either a character string name, or an address in the form a.b.c.d where
 * the pieces are octal, decimal, or hex numbers.  Returns a pointer to a
 * sockaddr_in struct (note this structure is statically allocated and must
 * be copied), or NULL if the name is unknown.
 */

register char *name;
{
	register struct hostent *fhost;
	static struct sockaddr_in sa;

	
	if ((sa.sin_addr.s_addr = inet_addr(name)) != -1) {
		sa.sin_family = AF_INET;	/* grot */
		sa.sin_port = 0;
	} else if ((fhost = gethostbyname(name)) != NULL) {
		sa.sin_family = fhost->h_addrtype;
		sa.sin_port = 0;
		bcopy(fhost->h_addr, &sa.sin_addr, fhost->h_length);
	} else
			return(NULL);
	return(&sa);
}
